{ --------------------------------------------------------------------------- }
{ TESTCMD.PAS	x86 Opcode Execution Test Source Code	 	Version 1.01  }
{									      }
{ Copyright(c) 1995 by B-coolWare.  Written by Bobby Z.			      }
{ Based on idea by Alen Scrinsky.					      }
{ May be freely used and distributed at no charge.                            }
{ --------------------------------------------------------------------------- }

uses Crt;

var
   DefRegs : Boolean;
   Regs: Record
	  _eax,
	  _ebx,
	  _ecx,
	  _edx,
	  _esi,
	  _edi,
	  _esp,
	  _ebp : Longint;
         end;

function ExecuteInstruction( Opcode : String; DefineRegs: Boolean ) : Boolean; far; external;
{ tries to execute instruction with opcode Opcode, returns True if it caused
  an "Invalid opcode" exception, False otherwise. }
{$L trap06}

function CvtStr( S : String ) : String;
var S1,R : String;
    i  : Byte;
    b  : Byte;
    C  : Integer;
begin
 CvtStr := '';
 R := '';
 if Length(S) mod 2 <> 0 then
  exit;
 i := 1;
 repeat
  S1 := '$'+Copy(S,i,2);
  Val(S1,b,C);
  if C <> 0 then
   exit;
  R := R + Char(b);
  Inc(i,2);
 until i >= Length(S);
 CvtStr := R;
end;

{ Some support code follows. It is quite unoptimal, but it works fine anyway. }

function HexB( B : Byte ) : String;
 const
      HexDigits : array[0..15] of Char = '0123456789ABCDEF';
 begin
  HexB := HexDigits[B shr 4] + HexDigits[B and $0F];
 end;

function HexW( W : Word ) : String;
 begin
  HexW := HexB(Hi(W))+HexB(Lo(W));
 end;

function HiWord( L : LongInt ) : Word; assembler;
asm
	mov	ax,word ptr L[2]
end;

function LoWord( L : LongInt ) : Word; assembler;
asm
	mov	ax,word ptr L
end;

function HexL( L : LongInt ) : String;
 begin
  HexL := HexW(HiWord(L))+HexW(LoWord(L));
 end;

function Str2Int( S : String ) : LongInt;
 var C : Integer;
     L : LongInt;
 begin
  Val('$'+S,L,C);
  if C <> 0 then
   Str2Int := 0
  else
   Str2Int := L;
 end;

var Opcode, InStr : String;

function YesNo : Boolean;
 var C : Char;
 begin
  repeat
   C := ReadKey;
  until Upcase(C) in ['Y','N'];
  WriteLn(C);
  YesNo := (Upcase(C) = 'Y');
 end;

const
	Trapped : array[Boolean] of String[13] = ('supported','NOT SUPPORTED');

begin
 WriteLn('x86 Opcode Execution Test  Version 1.01  Copyright(c) 1995 by B-coolWare.');
 WriteLn('Idea by Alen Scrinsky of 2:466/10.38@fidonet. Implementation by Bobby Z.');
 WriteLn;
 if ParamCount > 0 then
  begin
   Opcode := CvtStr(ParamStr(1));
   if Opcode = '' then
    begin
     WriteLn;
     WriteLn('Input is invalid. You must enter it in hexadecimal and with all zeros');
     WriteLn('in appropriate places. For example, opcode 0F A2 (P5 cpuid instruction)');
     WriteLn('must be entered as "0FA2".');
     Halt;
    end;
  end
 else
  begin
   Write('Enter opcode to test (hex, up to 10 bytes): ');
   ReadLn(InStr);
   Opcode := CvtStr(InStr);
   if Opcode = '' then
    begin
     WriteLn;
     WriteLn('Input is invalid. You must enter it in hexadecimal and with all zeros');
     WriteLn('in appropriate places. For example, opcode 0F A2 (P5 cpuid instruction)');
     WriteLn('must be entered as "0FA2".');
     Halt;
    end;
  end;
 Write('Define GP registers? [y/n] ');
 if YesNo then
  begin
   DefRegs := True;
   Write('EAX = ');
   ReadLn(InStr);
   if InStr <> '' then
    Regs._eax := Str2Int(InStr)
   else
    Regs._eax := 0;
   Write('EBX = ');
   ReadLn(InStr);
   if InStr <> '' then
    Regs._ebx := Str2Int(InStr)
   else
    Regs._ebx := 0;
   Write('ECX = ');
   ReadLn(InStr);
   if InStr <> '' then
    Regs._ecx := Str2Int(InStr)
   else
    Regs._ecx := 0;
   Write('EDX = ');
   ReadLn(InStr);
   if InStr <> '' then
    Regs._edx := Str2Int(InStr)
   else
    Regs._edx := 0;
   Write('ESI = ');
   ReadLn(InStr);
   if InStr <> '' then
    Regs._esi := Str2Int(InStr)
   else
    Regs._esi := 0;
   Write('EDI = ');
   ReadLn(InStr);
   if InStr <> '' then
    Regs._edi := Str2Int(InStr)
   else
    Regs._edi := 0;
   Write('ESP = ');
   ReadLn(InStr);
   if InStr <> '' then
    Regs._esp := Str2Int(InStr)
   else
    Regs._esp := 0;
   Write('EBP = ');
   ReadLn(InStr);
   if InStr <> '' then
    Regs._ebp := Str2Int(InStr)
   else
    Regs._ebp := 0;
  end
 else
  DefRegs := False;

 WriteLn('About to test entered opcode, the computer may hang...');
 WriteLn;
 WriteLn('The opcode is ',Trapped[ExecuteInstruction(Opcode,DefRegs)],' by CPU.');
 if DefRegs then
  begin
   WriteLn;
   WriteLn('GP registers after execution: ');
   WriteLn;
   WriteLn('EAX = ',HexL(Regs._eax),', EBX = ',HexL(Regs._ebx),', ECX = ',HexL(Regs._ecx),', EDX = ',HexL(Regs._edx));
   WriteLn('ESI = ',HexL(Regs._esi),', EDI = ',HexL(Regs._edi),', ESP = ',HexL(Regs._esp),', EBP = ',HexL(Regs._ebp));
  end;
end.
