; -----------------------------------------------------------------------------
; TRAP06.ASM	Low-level code for TESTCMD program		  Version 1.01
;
; Copyright(c) 1995 by B-coolWare.  Written by Bobby Z.
; Can be freely used and distributed at no charge.
; -----------------------------------------------------------------------------

	MODEL	TPASCAL		; define Turbo Pascal memory model

	.DATA

	EXTRN	Regs	: DWORD	; extended registers record

	.CODE

	LOCALS			; allow local labels
	JUMPS			; allow jump optimization

	.386			; allow 386 instruction set

	PUBLIC	ExecuteInstruction

ExecuteInstruction	proc far Opcode: DWORD, defRegs : BYTE
; tries to execute opcode [with registers set from Regs record if defRegs = 1]

	mov	cs:Trapped,0	; reset Trapped flag

;	now saving crucial registers

	mov	cs:_esp,esp
	mov	cs:_ebp,ebp
	mov	cs:_ds,ds
	mov	cs:_es,es
	mov	cs:_ss,ss
	mov	cs:_fs,fs
	mov	cs:_gs,gs

	push	ds

	lds	si,Opcode	; copy the instruction into internal buffer
	lodsb
	mov	cl,al
	sub	ch,ch
	mov	ax,ds
	pop	ds
	jcxz	@@Q
	cmp	cx,10
	ja	@@Q
	push	ds
	mov	ds,ax
	push	cs
	pop	es
	mov	di,offset @@instr
	cld
	rep	movsb
	mov	ax,3506h	; get INT 06 vector
	int	21h
	mov	cs:_oldcs,es
	mov	cs:_oldip,bx
	mov	ax,2506h	; and set our handler for trap 06
	push	cs
	pop	ds
	mov	dx,offset @@trap06
	int	21h
	pop	ds
	cmp	defRegs,1	; user given specific values to set registers to?
	jnz	@@instr
	mov	eax,ds:Regs	; set registers then
	mov	ebx,ds:Regs[4]
	mov	ecx,ds:Regs[8]
	mov	edx,ds:Regs[12]
	mov	esi,ds:Regs[16]
	mov	edi,ds:Regs[20]
	mov	esp,ds:Regs[24]
	mov	ebp,ds:Regs[28]
@@instr:
	db	10 dup(90h)
@@aftertrap:
	mov	cs:__eax,eax
	mov	ax,_ds
	mov	ds,ax
	mov	eax,cs:__eax
	mov	ds:Regs,eax	; store resulting registers back into record
	mov	ds:Regs[4],ebx
	mov	ds:Regs[8],ecx
	mov	ds:Regs[12],edx
	mov	ds:Regs[16],esi
	mov	ds:Regs[20],edi
	mov	ds:Regs[24],esp
	mov	ds:Regs[28],ebp
	mov	esp,cs:_esp	; restore possibly damaged registers
	mov	ebp,cs:_ebp
	mov	ax,cs:_gs
	mov	gs,ax
	mov	ax,cs:_fs
	mov	fs,ax
	mov	ax,cs:_ss
	mov	ss,ax
	mov	ax,cs:_es
	mov	es,ax
	push	ds
	mov	ax,cs:_oldcs	; restore old handler
	mov	ds,ax
	mov	dx,cs:_oldip
	mov	ax,2506h
	int	21h
	pop	ds
@@Q:
	mov	al,cs:Trapped
	ret
@@trap06:
	mov	cs:Trapped,1	; set Trapped flag
	add	sp,4		; pop address of invalid instruction off stack
	popf			; pop flags
	jmp	@@aftertrap	; skip after offending instruction
	endp

; internal variables

__eax	dd	?
_esp	dd	?
_ebp	dd	?
_ds	dw	?
_es	dw	?
_ss	dw	?
_fs	dw	?
_gs	dw	?
Trapped	db	0
_oldcs	dw	?
_oldip	dw	?

	END
